# FILE: class.tcl
#
# Bootstrap support for the first few calls to the command 
# 'em_class' which are made before the support database of
# extensions and cmdpkgs is created.

global _em_bootdir
set _em_bootdir [file dirname [file join [pwd] [string trimright \
    [file dirname [info script]] ./]]]

source [file join $_em_bootdir class.tcl]

;proc _em_cls_Sgetextension args {
  return _em_extension0
}

;proc _em_cls_Sgetcmdpkg {name pe thisfile} {
  if {[string match em_extension $name]} {
    return _em_cmdpkg3
  } elseif {[string match em_array $name]} {
    return _em_cmdpkg1
  } elseif {[string match em_log $name]} {
    return _em_cmdpkg4
  } elseif {[string match em_widgetlog $name]} {
    return _em_cmdpkg5
  } elseif {[string match em_channellog $name]} {
    return _em_cmdpkg6
  }
}

;proc _em_extension0 {subc args} {
  switch -exact -- $subc {
    cget {
      if {[string match -name [lindex $args 0]]} {
        return em
      }
      if {[string match -prefix [lindex $args 0]]} {
        return em
      }
    }
    cmdpkgs {
      return {}
    }
    directory {
      global _em_bootdir
      return $_em_bootdir
    }
    default {
      error "Incomplete bootstrap: $subc $args"
    }
  }
}

global _em_cmdpkg1
array set _em_cmdpkg1 {
_command em_array
_globalarray _em_array
_ibase _em_array
_hidpfx _em_ary_H
_impfx _em_ary_I
_pimpfx _em_ary_PI
_cmpfx _em_ary_C
_pcmpfx _em_ary_PC
}

global _em_cmdpkg3
array set _em_cmdpkg3 {
_command em_extension
_globalarray _em_extension
_ibase _em_extension
_hidpfx _em_ext_H
_impfx _em_ext_I
_pimpfx _em_ext_PI
_cmpfx _em_ext_C
_pcmpfx _em_ext_PC
}

global _em_cmdpkg4
array set _em_cmdpkg4 {
_command em_log
_globalarray _em_log
_ibase _em_log
_hidpfx _em_lg_H
_impfx _em_lg_I
_pimpfx _em_lg_PI
_cmpfx _em_lg_C
_pcmpfx _em_lg_PC
}

global _em_cmdpkg5
array set _em_cmdpkg5 {
_command em_widgetlog
_globalarray _em_widgetlog
_ibase _em_widgetlog
_hidpfx _em_wdg_H
_impfx _em_wdg_I
_pimpfx _em_wdg_PI
_cmpfx _em_wdg_C
_pcmpfx _em_wdg_PC
}

global _em_cmdpkg6
array set _em_cmdpkg6 {
_command em_channellog
_globalarray _em_channellog
_ibase _em_channellog
_hidpfx _em_chn_H
_impfx _em_chn_I
_pimpfx _em_chn_PI
_cmpfx _em_chn_C
_pcmpfx _em_chn_PC
}

foreach _em_cp [info globals _em_cmdpkg*] {
  ;proc $_em_cp {args} "
    upvar #0 $_em_cp state
    set firstarg \[lindex \$args 0\]
    switch -exact -- \$firstarg {
      default {
        if {\[info exists state(\$firstarg)\]} {
          return \$state(\$firstarg)
        } else {
          error \"Incomplete bootstrap: $_em_cp \$args\"
        }
      }
    }
  "
}

