# FILE: mmArchive.tcl
#

# Set up for auto-loading
set master(relhdir) [string trimright [file dirname [info script]] ./]
set master(abshdir) [file join [pwd] $master(relhdir)]
set master(pdir) [file dirname $master(abshdir)]
set master(libdir) [file dirname $master(pdir)]
if {[lsearch $auto_path $master(libdir)] < 0} {
    lappend auto_path $master(libdir)
}

# Support libraries
package require Tk
package require em
package require net

# Death
proc Die { win } {
    if {![string match "." $win]} { return }  ;# Child destroy event
    global protocol
    if {[info exists protocol]} {
	$protocol delete; after 2000 exit
    } else {
	exit
    }
}
bind . <Destroy> {+Die %W}

# Menu bar
set menubar [frame .mb -borderwidth 2 -relief raised]

set fmb [menubutton .fmb -text File -menu .fmb.menu -underline 0]
set fmenu [menu .fmb.menu -tearoff 0]
$fmenu add command -label "Exit" -command { Die . } -underline 1
pack $fmb -side left -in $menubar

pack $menubar -side top -fill x
set log [em_widgetlog new -dateformat "" -title mmArchive<[pid]>]
set protocol [net_protocol new -name "OOMMF vectorField protocol 0.0"]
$protocol AddMessage start datafile { fnlist } {
    set tmpfile [lindex $fnlist 0]
    set permfile [lindex $fnlist 1]
    global log
    $log Append "Writing $permfile ..."
    # Ought to add lots of error checking here...
    OMF_File rename $tmpfile $permfile
}
$protocol AddMessage start HasGui {} {
    return [list start [list 0 0]]
}
set server [net_server new -protocol $protocol -alias mmArchive -log em_nop]
$server Start 0
wm title . mmArchive<[pid]>
# Improve this later:
em_eventHandler new $log delete { after 2000 exit }
vwait omf_forever
